answer/urls.py
from django.urls import path
from . import views

app_name = 'answer'

urlpatterns = [
    path('answer-create/<int:question_id>/', views.answer_create, name='answer_create'),
    path('answer-update/<int:question_id>/<int:answer_id>/', views.answer_update, name='answer_update'),
    path('answer-delete/<int:question_id>/<int:answer_id>/', views.answer_delete, name='answer_delete'),
    path('answer-download/<int:id>/', views.download_file, name='download_file'),
]

collect/urls.py
#!/usr/bin/env python 
# -*- coding:utf-8 -*-
from django.urls import path
from . import views

app_name = 'collect'

urlpatterns = [
    path('collect-change/', views.collect_change, name='collect_change'),
]

like/urls.py
from django.urls import path
from . import views

app_name = 'like'

urlpatterns = [
    path('like-change/', views.like_change, name='like_change'),
]

question/urls.py
from django.urls import path
from . import views

app_name = 'question'

urlpatterns = [

    # 文章详情
    path('question-detail/<int:question_id>/', views.question_detail, name='question_detail'),
    path('question-create/', views.question_create, name='question_create'),
    path('question-update/<int:question_id>/', views.question_update, name='question_update'),
    path('question-delete/<int:question_id>/', views.question_delete, name='question_delete'),
    path('question-download/<int:question_id>', views.download_file, name='download_file'),
]

sailing/urls.py
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import render
from article import views as article_views
from question import views as question_views
from userprofile import views as user_views

from django.conf import settings
from django.conf.urls.static import static
from itertools import chain
import notifications.urls
def mainPage(request):
    return render(request, 'userprofile/collection.html', {})


def sort_column(column_questions, column_articles):
    column_content = []

    for question in column_questions:
        content = {'title': question.title, 'id': question.id, 'column': str(question.column), 'updated': question.updated, 'type': 'question'}
        column_content.append(content)
        pass

    for article in column_articles:
        content = {'title': article.title, 'id': article.id, 'column': str(article.column), 'updated': article.updated, 'type': 'article'}
        column_content.append(content)
        pass

    column_content = sorted(column_content, key=lambda x:(x['column'], x['updated']), reverse = True)
    
    #for item in column_content:
    #    if item['column'] != 'None':
    #        print(item)
    return column_content

def hot_content(request):
    # hotContent
    hot_questions = question_views.hot_question_list()
    hot_articles = article_views.hot_article_list()
    # blockContent
    column_questions = question_views.column_question_list()
    column_articles = article_views.column_article_list()
    column_content = sort_column(column_questions["column_questions"], column_articles["column_articles"])
    column_content = {'column_content': column_content}

    context = {**hot_questions, **hot_articles, **column_content}
    return render(request, 'mainPage.html', context)

urlpatterns = [
    path('admin/', admin.site.urls),
    path('userprofile/', include('userprofile.urls', namespace='userprofile')),
    path('article/', include('article.urls', namespace='article')),
    path('question/', include('question.urls', namespace='question')),
    path('comment/', include('comment.urls', namespace='comment')),
    path('answer/', include('answer.urls', namespace='answer')),
    path('like/', include('like.urls', namespace='like')),
    path('', hot_content, name='hot_content'),
    path('collect/', include('collect.urls', namespace='collect')),
    path('search_question/', question_views.search_question),
    path('search_article/', article_views.search_article),
    path('search_user/', user_views.search_user),
    path('blocks/',include('blocks.urls', namespace='blocks')),
    path('inbox/notifications/', include(notifications.urls, namespace='notifications')),
    path('notice/', include('notice.urls', namespace='notice')),
    # path('', mainPage)
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

question/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils import timezone
from django.urls import reverse
from django.contrib.contenttypes.fields import GenericRelation
from like.models import LikeRecord
from collect.models import CollectRecord


# 提问板块模型
class QuestionColumn(models.Model):
    # 板块标题
    title = models.CharField(max_length=100, blank=True)

    def __str__(self):
        return self.title


# 博客问题数据模型
class QuestionPost(models.Model):
    # 问题作者。
    author = models.ForeignKey(User, on_delete=models.CASCADE)

    # 问题版块。
    column = models.ForeignKey(
        QuestionColumn,
        null=True,
        blank=True,
        on_delete=models.CASCADE,
        related_name='question'
    )

    # 问题标题。
    title = models.CharField(max_length=100)

    # 问题描述。
    description = models.TextField(max_length=500)

    # 问题创建时间。参数 default=timezone.now 指定其在创建数据时将默认写入当前的时间
    created = models.DateTimeField(default=timezone.now)

    # 问题更新时间。参数 auto_now=True 指定每次数据更新时自动写入当前时间
    updated = models.DateTimeField(auto_now=True)

    # 上传文件
    file = models.FileField(upload_to='question_file/%Y%m%d/', blank=True)

    # 点赞记录
    like_records = GenericRelation(LikeRecord, related_query_name='articles')

    # 收藏记录
    collect_records = GenericRelation(CollectRecord, related_query_name='questions')

    # 浏览量
    total_views = models.PositiveIntegerField(default=0)

    class Meta:
        # ordering 指定模型返回的数据的排列顺序
        # '-created' 表明数据应该以创建时间的倒序排列
        ordering = ('-created',)

    def __str__(self):
        # 将问题标题返回
        return self.title

    # 获得问题详细页面url
    def get_absolute_url(self):
        return reverse('question:question_detail', args=[self.id])

    # 问题是否收藏
    def question_is_collected(self, user):
        return self.collect_records.filter(user=user).exists()

    # 问题是否点赞
    def question_is_liked(self, user):
        return self.like_records.filter(user=user).exists()

    # 问题创建时间是否错误
    @property
    def was_created_recently(self):
        diff = timezone.now() - self.created

        if diff.days == 0 and 0 <= diff.seconds < 60:
            return True
        else:
            return False

    # 问题更新时间是否错误
    def was_updated_recently(self):
        diff = timezone.now() - self.updated

        if diff.days == 0 and 0 <= diff.seconds < 60:
            return True
        else:
            return False

question/forms.py
from django import forms
from .models import QuestionPost


# 发布问题的表单类
class QuestionPostForm(forms.ModelForm):
    class Meta:
        # 指明数据模型来源
        model = QuestionPost
        # 定义表单包含的字段:问题属于的分区，标题，描述
        fields = ('title', 'description', 'file')

question/views.py
import os
import markdown

from django.shortcuts import render, redirect
from django.contrib.auth.models import User
from django.contrib.auth.decorators import login_required
from django.contrib import messages
from django.http import HttpResponse, StreamingHttpResponse
from django.conf import settings
from django.utils.http import urlquote
from django.db.models import Q  # 引入 Q 对象，进行组合查询
from django.core.paginator import Paginator  # 引入分页模块
from django.utils.html import strip_tags  # 去掉所有html标签

from .models import QuestionPost, QuestionColumn
from .forms import QuestionPostForm
from answer.models import Answer


def search_question(request):
    """
    搜索问题视图
    存在搜索内容，则返回与内容相关的问题，否则返回所有的问题(分页形式)
    """
    search = request.GET.get('search')  # 获取前端发送的搜索内容
    # 如果进行了搜索
    if search:
        questions = QuestionPost.objects.filter(
            # 匹配标题(i不区分大小写)
            Q(title__icontains=search) |
            # 匹配问题描述(不区分大小写)
            Q(description__icontains=search)
        ).order_by('-updated')
    # 如果未进行搜索
    else:
        # 获取所有问题
        question_list = QuestionPost.objects.all()
        # 每页显示 5 篇文章
        paginator = Paginator(question_list, 5)
        # 获取 url 中的页码
        page = request.GET.get('page')
        # 将导航对象相应的页码内容返回给questions
        questions = paginator.get_page(page)
    context = {'questions': questions, 'search_q': search}
    return render(request, 'search/search_question.html', context)


def hot_question_list():
    """
    获取热门问题函数，
    先按照总浏览量，后按照更新时间排序
    """
    questions = QuestionPost.objects.order_by('-total_views', '-updated')[:5]
    context = {'questions': questions}
    return context


def column_question_list():
    """
    获取板块问题函数，
    先按照板块(生活、学习、交友)，后按照更新时间排序
    """
    questions = QuestionPost.objects.all().order_by('column', '-updated')
    context = {'column_questions': questions}
    return context


def user_has_permission(user_id: int, perm_name: str) -> bool:
    """
    判断用户权限函数
    根据传入的用户名和权限名称，返回该用户是否拥有该权限的bool变量
    """
    cur_user = User.objects.get(id=user_id)
    return cur_user.has_perm(perm_name)


def question_detail(request, question_id):
    """
    问题详情视图
    根据传入的问题id，返回该问题的详情界面
    """
    question = QuestionPost.objects.get(id=question_id)
    # 更新浏览量
    question.total_views += 1
    # 保存新的浏览量
    question.save(update_fields=['total_views'])
    question.description = strip_tags(question.description)
    # 包含缩写、表格等常用扩展 和 语法高亮扩展
    question.description = markdown.markdown(question.description,
                                             extensions=['markdown.extensions.extra',
                                                         'markdown.extensions.codehilite'])
    # 获取该问题的所有回答
    answers = Answer.objects.filter(question=question_id)
    context = {'question': question, 'answers': answers}
    return render(request, 'question/detail.html', context)


@login_required(login_url='/userprofile/login/')
def question_create(request):
    """
    发布问题视图

    判断 权限 后，
    通过POST提交创建问题，返回问题详情界面，
    GET方式进入创建问题界面
    """
    # 判断该用户是否有相关权限
    if not user_has_permission(request.user.id, 'question.add_questionpost'):
        return HttpResponse('抱歉，您的相关权限已被管理员封禁；如有疑问，请联系管理员！！！')

    is_initial = True  # 标识用户创建问题

    # 判断用户是否提交数据
    if request.method == "POST":
        # 将提交的数据赋值到表单实例
        question_post_form = QuestionPostForm(request.POST, request.FILES)
        # 判断提交的数据是否满足要求
        if question_post_form.is_valid():
            # 保存数据，但暂时不提交到数据库
            new_question = question_post_form.save(commit=False)
            # 指定用户为当前session中存在(已登录)用户
            new_question.author = User.objects.get(id=request.user.id)
            # 所有问题都需要归属于一个板块
            new_question.column = QuestionColumn.objects.get(id=request.POST['column'])
            # 将文章保存至数据库
            new_question.save()
            # 完成后提示发表成功
            messages.success(request, "发表问题成功。")
            # 完成后返回到文章详情
            return redirect(new_question)
        # 数据不合法 ，返回错误信息
        else:
            context = {'is_initial': is_initial}
            messages.error(request, "表单内容有误，请重新填写。")
            return render(request, "question/create_update.html", context)
    # 如果用户请求获取数据
    else:
        context = {'is_initial': is_initial}
        return render(request, 'question/create_update.html', context)


# 更新问题
@login_required(login_url='/userprofile/login/')
def question_update(request, question_id):
    """
    更新文章视图

    判断 权限、用户是否相同 后
    通过POST提交表单，更新title,body字段
    GET方法进入初始界面

    question_id: 问题id
    """
    # 判断该用户是否有相关权限
    if not user_has_permission(request.user.id, 'question.change_questionpost'):
        return HttpResponse('抱歉，您的相关权限已被管理员封禁；如有疑问，请联系管理员！！！')
    # 获取需要修改的具体文章的对象
    question = QuestionPost.objects.get(id=question_id)
    # 只能修改本人的问题
    if request.user != question.author:
        messages.error(request, "抱歉，你无权修改这篇文章")
        return redirect(question)

    is_initial = False  # 用于判断是编辑问题

    # 判断用户是否为 POST提交表单数据
    if request.method == "POST":
        # 将提交的数据保存在表单实例中
        question_post_form = QuestionPostForm(request.POST, request.FILES)

        # 判断提交的数据是否满足模型要求
        if question_post_form.is_valid():
            # 保存新鞋入的title,body
            question_cd = question_post_form.cleaned_data
            question.title = question_cd['title']
            question.description = question_cd['description']

            if request.POST['column'] != 'none':
                question.column = QuestionColumn.objects.get(id=request.POST['column'])
            else:
                question.column = None

            if 'file' in request.FILES:
                question.file = question_cd['file']  # 取文件对象

            question.save()
            # 默认调用question model中的get_absolute_url方法
            return redirect(question)
        else:
            context = {'question': question, 'is_initial': is_initial}
            messages.error(request, "表单内容有误，请重新填写。")
            return render(request, "question/create_update.html", context)
    # 如果用户GET请求获取数据
    else:
        # 赋值上下文 将question对象也穿进去，方便提取旧的内容
        context = {'question': question, 'is_initial': is_initial}
        # 将响应返回到模板中渲染
        return render(request, 'question/create_update.html', context)


@login_required(login_url='/userprofile/login/')
def question_delete(request, question_id):
    """
    删除问题视图

    修改为只能通过POST方式才能成功删除，GET方式或非问题作者用户无法删除文章

    question_id: 问题id
    """
    question = QuestionPost.objects.get(id=question_id)  # 根据id获取需要删掉的问题
    if request.method == "POST":
        if request.user != question.author:
            messages.error(request, "抱歉，你无权删除此问题！")  # 只能删除本人的问题
            return redirect(question)
        else:
            question.delete()  # 调用.delete()方法删除问题
            messages.success(request, "删除问题成功！点击确定跳转首页！")
            return redirect("/")  # 完成后返回主页
    # 其他请求方式无法删除问题
    else:
        messages.error(request, "抱歉，你无法通过此方式删除此问题！")
        return redirect(question)


@login_required(login_url='/userprofile/login/')
def download_file(request, question_id):
    """
    下载附件视图

    判断用户权限后，即可下载问题附件到本地

    question_id: 问题id
    """
    # 判断该用户是否有相关权限
    if not user_has_permission(request.user.id, 'question.view_questionpost'):
        return HttpResponse('抱歉，您的相关权限已被管理员封禁；如有疑问，请联系管理员！！！')

    question = QuestionPost.objects.get(id=question_id)

    filepath = os.path.join(settings.MEDIA_ROOT, str(question.file))
    filename = str(question.file).split("/")[-1]  # 显示在弹出对话框中的默认的下载文件名

    fp = open(filepath, 'rb')
    response = StreamingHttpResponse(fp)
    response['Content-Type'] = 'application/octet-stream'

    response['Content-Disposition'] = 'attachment;filename="{0}"'.format(urlquote(filename.encode('utf8')))
    return response

templates/question/create_update.html
{% extends "base.html" %}
{% load staticfiles %}

{% block title %}
    {% if is_initial %}发布问题{% else %}更新问题{% endif %}
{% endblock title %}

{% block content %}
    <div class="container">
        <div class="row">
            <div class="col-12">
                <br>
                <!-- 提交文章的表单 -->
                <form method="post" enctype="multipart/form-data" action=".">
                    <!-- Django中需要POST数据的地方都必须有csrf_token -->
                    {% csrf_token %}
                    <!-- 文章标题 -->
                    <div class="form-group">
                        <!-- 标签 -->
                        <label for="title">问题标题</label>
                        <!-- 在 value 属性中指定文本框的初始值为旧的内容，即 question 对象中的 title 字段 -->
                        <input type="text" class="form-control" id="title" name="title" {% if not is_initial %}
                           value="{{ question.title }}" {% endif %} required/>
                    </div>
                    <!-- 文章正文 -->
                    <div class="form-group">
                        <label for="description">问题描述</label>
                        <!-- 文本域不需要 value 属性，直接在标签体中嵌入数据即可 -->
                        <textarea type="text" class="form-control" id="description" name="description" rows="12"
                                  required>{% if not is_initial %}{{ question.description }}{% endif %}</textarea>
                    </div>
                    <!-- 问题板块 -->
                    <div class="form-group">
                        <label for="column">板块</label>
                        <!-- 文章id和name需要修改！！！ -->
                        <select class="form-control col-3" id="column" name="column" required>
                            <option value="">{请选择板块}..</option>
                            <option value=1>生活</option>
                            <option value=2>学习</option>
                            <option value=3>交友</option>
                            {% if not is_initial %}
                            <!-- 动态显示问题原始板块-->
                            <script type="text/javascript">
                                var col = "{{ question.column }}";
                                var select = document.getElementById("column")
                                for (var i = 0; i < select.options.length; i++) {
                                    if (select.options[i].text === col) {
                                        select.options[i].selected = true;
                                        break;
                                    }
                                }
                            </script>
                            {% endif %}
                        </select>
                    </div>
                    <!-- 上传文件 -->
                    <div class="form-group">
                        <label for="file">上传文件</label> <!--这里是file不是files-->
                        <input type="file" class="form-control-file" name="file" id="file">
                    </div>
                    <!-- 提交按钮 -->
                    <button type="submit" class="btn btn-primary">{% if is_initial %}提交问题
                    {% else %}完成{% endif %}</button>
                </form>
            </div>
        </div>
    </div>

    {% if messages %}
        <!--弹框形式-->
        <script>
            {% for msg in messages %}
                alert('{{ msg.message }}');
            {% endfor %}
        </script>
    {% endif %}
{% endblock content %}

templates/question/detail.html
{% extends "base.html" %}
{% load staticfiles %}
{% load like_tags %}
{% load collect_tags %}

<!-- 写入 base.html 中定义的 title -->
{% block title %}
问题详情
{% endblock title %}

<!-- 写入 base.html 中定义的 content -->
{% block content %}
<div class="container">
    <div class="row">
        <h1 class="col-12 mt-4 mb-4">{{ question.title }}</h1>
        <div class="col-12 alert alert-success">
            <div>
                版块：{{ question.column }}
            </div>
            <div>
                作者：{{ question.author }}
                {% if user == question.author %}
{#                    隐藏表单，用于POST提交删除信息 #}
                    <form style="display: none" id="question-delete-form" action="{% url 'question:question_delete' question.id %}" method="POST">
                        {% csrf_token %}
                        <button type="submit">发送</button>
                    </form>
                    <a href="#" onclick="confirm_delete()">删除问题</a><!--要修改删除url，去下面scripe中找confirm_delete中的location.href-->
                    <a href="{% url 'question:question_update' question.id %}">编辑问题</a>
                {% endif %}
            </div>
            {% if question.file %}
            <div style="color:gray">
                附件名称:   {{ question.file }}
            </div>
            {% endif %}
        </div>

        <div class="col-12">
            <p>{{ question.description|safe }} </p>
        </div>
    </div>



        <div class="d-flex justify-content-center">
            {% if question.file %}
            <button type="button" class="btn btn-primary mr-4" onclick="window.location.href='{% url 'question:download_file' question.id %}'">下载附件</button>
            {% endif %}
            <a href="{% url 'answer:answer_create' question.id %}">
                <button type="button" class="btn btn-primary mr-4">写回答</button>
            </a>

            {% if user.is_authenticated %}
            <button type="button" class="btn btn-link" style="text-decoration:none;color:darkslategrey;" onclick="like_change('questionpost', {{ question.id }})">
                    {% if question|add_arg:request.user|call:"question_is_liked" %}
                    <span id="like-container"><i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i></span>
                    {% else %}
                    <span id="like-container"><i id="like-icon" class="far fa-heart" style="font-size:20px;"></i></span>
                    {% endif %}
                    点赞
                    <span id="likes_number">{% get_likes_num question %}</span>
            </button>

            <button type="button" class="btn btn-link btn-sm" style="text-decoration:none;color:darkslategrey;" onclick="collect_change('questionpost', {{ question.id }})">
                    {% if question|add_arg:request.user|call:"question_is_collected" %}
                    <span id="collect-container"><i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i></span>
                    {% else %}
                    <span id="collect-container"><i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i></span>
                    {% endif %}
                    收藏
                    <span id="collect_number">{% get_collect_num question %}</span>
            </button>
            {% endif %}
        </div>


    <!-- 显示回答 -->
    <h4>共有{{ answers.count }}个回答</h4>
    <div>
        {% for answer in answers %}
        <p>
            <!-- 作者 -->
            <strong style="color: pink">{{ answer.user }}</strong>
        </p>
        <!-- 文章内容 -->
        <pre style="font-family: inherit; font-size: 1em;">{{ answer.body }}</pre>
        <p>
            <ul class="nav nav-tabs">
            <li>
                <span>
                <!-- 下拉列表 -->
                <div class="dropdown"  style="display:inline-block;">
                <button type="button" class="btn dropdown-toggle" id="dropdownMenu1"
                    data-toggle="dropdown" value=".btn .btn-primary"style="height:35px; width:40px;">

                    <span class="caret"></span>
                </button>

{#                <style type="text/css" rel="stylesheet">a{color:black;}</style>#}
                <ul class="dropdown-menu" role="menu" aria-labelledby="dropdownMenu1">
                    {% if answer.file %}
                    <li role="presentation">
                        <a onclick="window.location.href='{% url 'answer:download_file' answer.id %}'" href="#">下载附件</a>
                    </li>
                    {% endif %}

                    {% if user == answer.user %}
                    <li role="presentation">
                        <a  href="{% url 'answer:answer_update' question.id answer.id %}">编辑回答</a>
                    </li>
                    <li role="presentation">
                        <a href="#" onclick="confirm_delete_comment({{ question.id }}, {{ answer.id }})">删除该回答</a>
                    </li>
                    {% endif %}

                    <li role="presentation">
                        等待更多操作...
                    </li>
                </ul>
            </div>

                </span>
            </li>

            <!-- 点赞 -->
            {% if user.is_authenticated %}
            <li>
            <button type="button" class="btn btn-link btn-sm" style="text-decoration:none;color:darkslategrey;" onclick="like_change('answer', {{ answer.id }})">
                {% if answer|add_arg:request.user|call:"answer_is_liked" %}
                <span id="like-container{{answer.id}}"><i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i></span>
                {% else %}
                <span id="like-container{{answer.id}}"><i id="like-icon" class="far fa-heart" style="font-size:20px;"></i></span>
                {% endif %}
                点赞
                <span id="likes_number{{answer.id}}">{% get_likes_num answer %}</span>
            </button>
            </li>

            <!-- 收藏 -->
            <li>
            <button type="button" class="btn btn-link btn-sm" style="text-decoration:none;color:darkslategrey;" onclick="collect_change('answer', {{ answer.id }})">
                {% if answer|add_arg:request.user|call:"answer_is_collected" %}
                <span id="collect-container{{answer.id}}"><i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i></span>
                {% else %}
                <span id="collect-container{{answer.id}}"><i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i></span>
                {% endif %}
                收藏
                <span id="collect_number{{answer.id}}">{% get_collect_num answer %}</span>
            </button>
            </li>
            {% endif %}
            <!-- 时间 -->
            <li>
                <span style="color: green">{{ answer.created|date:"Y-m-d H:i:s" }}</span>
            </li>
            </ul>
        </p>
        {% endfor %}
    </div>


</div>

{% if messages %}
<!--弹框形式-->
<script>
    {% for msg in messages %}
        alert('{{ msg.message }}');
    {% endfor %}
</script>
<!--左下角弹框形式-->
<!--<ul class="messages">-->
<!--    {% for message in messages %}-->
<!--    <li {% if message.tags %} class="{{ message.tags }}" {% endif %}>{{ message }}</li>-->
<!--    {% endfor %}-->
<!--</ul>-->
<!--{% endif %}-->
{% endblock content %}

{% block script %}
<script>
    // 删除文章的函数
    function confirm_delete() {
        // 调用layer弹窗组件
        layer.open({
            // 弹窗标题
            title: "确认删除",
            // 正文
            content: "确认删除该问题吗？",
            // 点击确定按钮后调用的回调函数
            yes: function(index, layero) {
                $("#question-delete-form button").click(); // 提交POST删除信息
                layer.close(index);
            },
        })
    }
</script>
<script>
    // 删除文章的函数
    function confirm_delete_comment(question_id, answer_id) {
        // 调用layer弹窗组件
        layer.open({
            // 弹窗标题
            title: "确认删除",
            // 正文
            content: "确认删除该回答吗？",
            // 点击确定按钮后调用的回调函数
            yes: function(index, layero) {
                // 指定应当前往的 url
                var url = "{% url 'answer:answer_delete' 210000000 220000000 %}";
                url = url.replace(/210000000/, question_id);
                url = url.replace(/220000000/, answer_id);
                location.href=url
            },
        });
    }
</script>
<script>
    function like_change(content_type, object_id) {
        $.ajax({
            url: "{% url 'like:like_change' %}",
            type: 'GET',
            data: {
                content_type: content_type,
                object_id: object_id,
            },
            cache: false,
            success: function (data) {
                console.log(data);
                if(content_type=="articlepost" || content_type=="questionpost"){
                    if(data.is_liked){
                        $("#like-container").html('<i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i>');
                    }
                    else{
                        $("#like-container").html('<i id="like-icon" class="far fa-heart" style="font-size:20px;"></i>');
                    }
                    $("#likes_number").html(data.likes_num);
                }
                else{
                    var container = '#like-container'+object_id;
                    if(data.is_liked){
                        $(container).html('<i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i>');
                    }
                    else{
                        $(container).html('<i id="like-icon" class="far fa-heart" style="font-size:20px;"></i>');
                    }
                    var number = '#likes_number'+object_id;
                    $(number).html(data.likes_num);
                }

            },
            error: function (xhr) {
                console.log(xhr);
            }
        });
    }

    function collect_change(content_type, object_id) {
        $.ajax({
            url: "{% url 'collect:collect_change' %}",
            type: 'GET',
            data: {
                content_type: content_type,
                object_id: object_id,
            },
            cache: false,
            success: function (data) {
                console.log(data);
                if(content_type=="articlepost" || content_type=="questionpost") {
                    if (data.is_collected) {
                        $("#collect-container").html('<i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i>');
                    } else {
                        $("#collect-container").html('<i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i>');
                    }
                    $("#collect_number").html(data.collect_num);
                }
                else{
                    var container = '#collect-container'+object_id;
                    if(data.is_collected){
                        $(container).html('<i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i>');
                    }
                    else{
                        $(container).html('<i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i>');
                    }
                    var number = '#collect_number'+object_id;
                    $(number).html(data.collect_num);
                }
            },
            error: function (xhr) {
                console.log(xhr);
            }
        });
    }

</script>
{% endblock script %}